// Generated by gencpp from file actionlib_tutorials/AveragingGoal.msg
// DO NOT EDIT!


#ifndef ACTIONLIB_TUTORIALS_MESSAGE_AVERAGINGGOAL_H
#define ACTIONLIB_TUTORIALS_MESSAGE_AVERAGINGGOAL_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace actionlib_tutorials
{
template <class ContainerAllocator>
struct AveragingGoal_
{
  typedef AveragingGoal_<ContainerAllocator> Type;

  AveragingGoal_()
    : samples(0)  {
    }
  AveragingGoal_(const ContainerAllocator& _alloc)
    : samples(0)  {
  (void)_alloc;
    }



   typedef int32_t _samples_type;
  _samples_type samples;





  typedef boost::shared_ptr< ::actionlib_tutorials::AveragingGoal_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::actionlib_tutorials::AveragingGoal_<ContainerAllocator> const> ConstPtr;

}; // struct AveragingGoal_

typedef ::actionlib_tutorials::AveragingGoal_<std::allocator<void> > AveragingGoal;

typedef boost::shared_ptr< ::actionlib_tutorials::AveragingGoal > AveragingGoalPtr;
typedef boost::shared_ptr< ::actionlib_tutorials::AveragingGoal const> AveragingGoalConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::actionlib_tutorials::AveragingGoal_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::actionlib_tutorials::AveragingGoal_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace actionlib_tutorials

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsMessage': True, 'IsFixedSize': True, 'HasHeader': False}
// {'actionlib_tutorials': ['/home/eaibot/2022_jsjds/ros_ws/devel/.private/actionlib_tutorials/share/actionlib_tutorials/msg'], 'std_msgs': ['/home/eaibot/2022_jsjds/ros_ws/install/share/std_msgs/cmake/../msg'], 'actionlib_msgs': ['/home/eaibot/2022_jsjds/ros_ws/install/share/actionlib_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__dir__', '__doc__', '__eq__', '__format__', '__ge__', '__getattribute__', '__gt__', '__hash__', '__init__', '__init_subclass__', '__le__', '__lt__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsMessage< ::actionlib_tutorials::AveragingGoal_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::actionlib_tutorials::AveragingGoal_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::actionlib_tutorials::AveragingGoal_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::actionlib_tutorials::AveragingGoal_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::actionlib_tutorials::AveragingGoal_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::actionlib_tutorials::AveragingGoal_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::actionlib_tutorials::AveragingGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "32c9b10ef9b253faa93b93f564762c8f";
  }

  static const char* value(const ::actionlib_tutorials::AveragingGoal_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x32c9b10ef9b253faULL;
  static const uint64_t static_value2 = 0xa93b93f564762c8fULL;
};

template<class ContainerAllocator>
struct DataType< ::actionlib_tutorials::AveragingGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "actionlib_tutorials/AveragingGoal";
  }

  static const char* value(const ::actionlib_tutorials::AveragingGoal_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::actionlib_tutorials::AveragingGoal_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======\n\
#goal definition\n\
int32 samples\n\
";
  }

  static const char* value(const ::actionlib_tutorials::AveragingGoal_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::actionlib_tutorials::AveragingGoal_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.samples);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct AveragingGoal_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::actionlib_tutorials::AveragingGoal_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::actionlib_tutorials::AveragingGoal_<ContainerAllocator>& v)
  {
    s << indent << "samples: ";
    Printer<int32_t>::stream(s, indent + "  ", v.samples);
  }
};

} // namespace message_operations
} // namespace ros

#endif // ACTIONLIB_TUTORIALS_MESSAGE_AVERAGINGGOAL_H
